#!/usr/bin/ruby
# encoding: utf-8

class LicenseScreen

	def initialize(layers, fixed, topbuttons)
		@layers = layers
		@fixed = fixed
		@top_buttons = topbuttons
		lang = ENV['LANGUAGE'][0..1]
		lang = ENV['LANG'][0..1] if lang.nil?
		lang = "en" if lang.nil?
		@tl = MfsTranslator.new(lang, "LicenseScreen.xml") 
		create_first_layer 
	end
	
	def create_first_layer
		bgimg = Gtk::Image.new("background.png")
		fx = Gtk::Fixed.new
		cancel = Gtk::Button.new(Gtk::Stock::NO) 
		ok = Gtk::Button.new(Gtk::Stock::YES)
		fx.put(bgimg, 0, 0)
		# Label
		infolabel = Gtk::Label.new
		infolabel.wrap = true
		infolabel.width_request = 730
		infolabel.set_markup(@tl.get_translation("license_start"))
		fx.put(infolabel, 250, 100)
		# Text area
		txarea = Gtk::TextView.new
		txarea.wrap_mode = Gtk::TextTag::WRAP_WORD
		eula = "Ooops, no EULA found!"  
		if File.exist?("eula.#{@lang}.txt")
			disctext = File.new("eula.#{@lang}.txt").read
		else
			disctext = File.new("eula.en.txt").read
		end
		txarea.buffer.text = disctext 
		txarea.width_request = 728
		txarea.height_request = 235
		scrolled_win = Gtk::ScrolledWindow.new
		scrolled_win.border_width = 3
		scrolled_win.add(txarea)
		scrolled_win.set_policy(Gtk::POLICY_AUTOMATIC, Gtk::POLICY_ALWAYS)
		fx.put(scrolled_win, 247, 220)
		# Input field for license key
		liclabel = Gtk::Label.new(@tl.get_translation("license_key")) 
		liclabel.height_request = 32
		fx.put(liclabel, 250, 468)
		licinput = Gtk::Entry.new
		licinput.height_request = 32
		licinput.width_request = 534
		fx.put(licinput, 458, 468)
		# Text to ask if accepted or not
		acclabel = Gtk::Label.new
		acclabel.wrap = true 
		acclabel.width_request = 730
		acclabel.set_markup(@tl.get_translation("do_you_accept")) 
		# fx.put(acclabel, 250, 468)
		[ ok, cancel ].each { |w|
			w.width_request = 128
			w.height_request = 32 
		}
		cancel.signal_connect("clicked") { 
			system("shutdown-wrapper.sh") 
		}
		ok.signal_connect("clicked") { 
			@layers.each { |k,v| v.hide_all }
			FileUtils.touch("/var/run/lesslinux/license_accepted") 
			@layers["start"].show_all 
			@top_buttons.each { |v| v.show_all }
		}
		fx.put(ok, OK_X, OK_Y)
		fx.put(cancel, CANCEL_X, CANCEL_Y)
		@fixed.put(fx, 0, 0)
		@layers["license"] = fx
	end
	
end

